#include <AT24CXXX.h>
#include <Wire.h>

AT24CXXX ROM_512;

void setup()
{
  Wire.begin();        //启动I2C通信
  Serial.begin(9600);
  
  ROM_512.Memory_Size(512);
  //512K内部地址:  0x0000——0xffff
  //32K内部地址:   0x0000——0x0fff
  //2K内部地址:    0x0000——0x00ff
}

void loop()
{
  //数据字节数组
  byte b[2]={0xb0,0xb1};
  byte c[4]={0xc0,0xc1,0xc2,0xc3};
  
  //用来存储接受字节数组
  byte a0[4]={0xff,0xff,0xff,0xff};
  byte a1[4]={0xff,0xff,0xff,0xff};
  byte* q0 = a0;
  byte* q1 = a1;
  
  //WriteBuffer（硬件地址位，内部地址位，一个字节数组，开始位，字节数）
  ROM_512.WriteBuffer(0x50 ,0x0000 ,b ,0 ,2);
  ROM_512.WriteBuffer(0x50 ,0x00ff ,c ,0 ,4);
  
  //ReadBuffer（硬件地址位，内部地址高8位，内部地址低8位，存储字节数组，字节数）  
  q0 = ROM_512.ReadBuffer(0x50 ,0x0000 ,a0 ,2);
  q1 = ROM_512.ReadBuffer(0x50 ,0x00ff ,a1 ,4);
  
  Serial.print("test_0=\n");delay(10);
  Serial.println( a0[0],HEX );delay(10);
  Serial.println( a0[1],HEX );delay(1000);
  
  Serial.print("test_1=\n");delay(10);
  Serial.println( a1[0],HEX );delay(10);
  Serial.println( a1[3],HEX );delay(1000);
}
